#ifndef __TRANSFORMRESIDULAS_H__
#define __TRANSFORMRESIDULAS_H__
 
#include "Kinship.h"
#include "KinshipX.h"
#include "KinshipEmp.h"
#include "MathNormal.h"
#include "MathVector.h"
#include "StringBasics.h"
#include "MathMatrix.h"
#include "MathCholesky.h"
#include "AutoFit.h"

class FastTransform
{
        public:
	FastTransform();
        ~FastTransform();

	static bool empKin;
	static bool pedKin;
	static String readInEmp;
	
	//# of useful families and individuals
	int families,persons,fixedEffects;
	double traitVar,traitMean;

	//Hash of sample ids from vcf file, if reading from vcf is needed
	StringIntHash sampleVCFIDHash,samplePEDIDHash,foundersHash;

	IntArray * pPheno;
	StringArray founders;
	//Saved Matrices for likelihood calculation
	Matrix X,UX,transU;
	Vector D,UY,Y; 
	Matrix UDX,UD,inv; //here D is D^1/2
	Vector UDY; //D is D^1/2

	//Reformat LL* into UDU*U
	void ReformCholesky(Matrix & L, Vector & D);
	int GetTraitID(Pedigree & ped, const char * name);
	//These function are transformation work horses
	void TransformPedkin(Pedigree & ped, int traitNum,bool useCovaraites);
	void TransformEmpkin(Pedigree & ped, int traitNum,bool useCovariates);
	void GetFixedEffectsCount(Pedigree & ped, bool useCovariates);
	void Prepare(Pedigree & ped, int traitNum,bool useCovariates);
	void TransformPedkinSibEnv(AutoFit & engine, Pedigree &ped);
	void FinalizeTransform(double sigma_g2,double sigma_e2);
	void SubSet(Matrix & kin,Pedigree & ped);
};

#endif
